/******************************************************************************
*******************************************************************************

	GLfont
	relminator (Richard Eric M. Lope BSN RN)
	http://rel.betterwebber.com


	main() entry point
	
	
 
*******************************************************************************
******************************************************************************/


#include <nds.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "Csprite.h"
#include "Coamfont.h"


// GRIT headers
#include "font_oam.h"
#include "font_oam_16x16.h"


/******************************************************************************
*******************************************************************************
	MAIN entry point


*******************************************************************************
******************************************************************************/








int Csprite::num_sprites = 0;

Coamfont oamfont;
Coamfont oamfont_sub;




int main(int argc, char *argv[])
{
	
	
	
	videoSetMode(MODE_5_3D);
	videoSetModeSub(MODE_5_2D);
	
	
	consoleDemoInit();
	
	//iprintf("\x1b[1;1HSpace Impakto DS");
	//iprintf("\x1b[2;1HRelminator");
	
	
	vramSetBankA(VRAM_A_MAIN_SPRITE);
	vramSetBankB(VRAM_B_MAIN_SPRITE);
	vramSetBankD(VRAM_D_SUB_SPRITE);
	
	//api: initialize OAM to 1D mapping with XX byte offsets and no external palette
	oamInit(&oamMain, SpriteMapping_1D_128, false);
	oamInit(&oamSub, SpriteMapping_1D_128, false);

	// palette
	dmaCopy(font_oamPal, SPRITE_PALETTE, 512);
	dmaCopy(font_oamPal, SPRITE_PALETTE_SUB, 512);
	
	
	oamfont.init(&oamMain, (u8*)font_oam_16x16Tiles, 16, 16, SpriteSize_16x16, 96);
	oamfont_sub.init(&oamSub, (u8*)font_oamTiles, 8, 8, SpriteSize_8x8, 96);
	
	
	int total_frame = 0;
	
	oamfont.print_centered(30, 40, "ERIC LOPE");
	
	oamfont.print_spaced(30, 120, "RELMINATOR", 8, 0, 0 );
	
	oamfont.print_vertical(10, 10, "ERIC LOPE");
	oamfont.print(30, 80,  oamfont.active_chars);
	
	int keys;
	s32 spacing = 8 << 12;
	
	while(1)
	{
	
		scanKeys();
		keys = keysDown();
		
		if(keys & KEY_A)
		{
			spacing = 8 << 12;
		}
		
		if (spacing > 0)
			spacing -= 256;
			
		oamfont_sub.clear(); // deactivate every oam per frame
		
		oamfont_sub.print_centered(10, 40, "Anya Therese");
		oamfont_sub.print_score(10, 60, total_frame, "0", 7);
		
		
		
		
		oamfont_sub.print(10, 100 , "FRAME = ", total_frame);
		
		oamfont_sub.print_spaced(10, 120 , "ANYATECH", 2, floattof32(2.5),0);
		
		oamfont_sub.print_spaced(10, 140 , "ANYATECH", 0, spacing, 0);
		
		total_frame++;
		
		//oamfont_sub.print(10, 80,  oamfont_sub.active_chars);
	
		swiWaitForVBlank();
		
		oamUpdate(&oamMain);
		oamUpdate(&oamSub);
		
		//consoleClear();
		//iprintf("\x1b[14;1HSprites      = %i           ", oamfont.fonts[0].num_sprites);
		iprintf("\x1b[23;1HActive Chars = %i           ", oamfont_sub.active_chars);
		
	}

	
	return 0;
	
}



